-- This design blinks the userled of a efm02 

library ieee;
	use ieee.std_logic_1164.all;
	use ieee.numeric_std.all;
	use ieee.math_real.all;

library unisim;
	use unisim.vcomponents.all;

    
entity efm02_ledblink is
  port (
  
  
  port_in : in std_logic_vector (8 downto 0);
  port_out : out std_logic_vector (8 downto 0);
  
    pin_clk100_i	: in std_logic; -- external oscillator (default: 100 MHz)
	pin_user_led_o	: out std_logic -- source of FX-3 <--> FPGA clock network on PCB
 );
end efm02_ledblink;


architecture rtl of efm02_ledblink is
      
  	constant clk_frequency_Hz			: real := 100.0e+6; -- 100 MHz
	constant BlinkingLedFrequency		: real := 1.0;  -- 1/2 Hz 
	constant BlinkingLedToggleCycles 	: positive := integer(ceil(clk_frequency_Hz / (2.0 * BlinkingLedFrequency)));

	signal BlinkingLed				: std_logic := '0';
  
begin  -- rtl

	
    
	-----------------------------------------------------------------------------------------------
	-- Blink the Led !
	-----------------------------------------------------------------------------------------------

port_out <= port_in;

	process (pin_clk100_i)
		variable cnt: INTEGER RANGE 0 to BlinkingLedToggleCycles;
	begin
		if rising_edge (pin_clk100_i) then
                if (cnt = 0) then
                    cnt := BlinkingLedToggleCycles ;
                    BlinkingLed <= not BlinkingLed;
                else
                    cnt := cnt - 1;
                end if;
           
		end if;
	end process;

	pin_user_led_o <= BlinkingLed;

	
end rtl;
