--------------------------------------------------------------------------------
-- copyright notice:
--------------------------------------------------------------------------------
-- copyright (c) 2010 by
--
-- CESYS GmbH / GERMANY
--
-- http://www.cesys.com
--------------------------------------------------------------------------------
-- author:
--------------------------------------------------------------------------------
-- Stefan Fischer <Stefan.Fischer@cesys.com>
--------------------------------------------------------------------------------
-- license:
--------------------------------------------------------------------------------
-- THIS SOURCECODE IS NOT FREE! IT IS FOR USE TOGETHER WITH CESYS PRODUCTS ONLY!
-- YOU ARE NOT ALLOWED TO MODIFY AND DISTRIBUTE OR USE IT WITH ANY OTHER
-- HARDWARE, SOFTWARE OR ANY OTHER KIND OF ASIC OR PROGRAMMABLE LOGIC DESIGN
-- WITHOUT THE EXPLICIT PERMISSION OF THE COPYRIGHT HOLDER!
--------------------------------------------------------------------------------
-- disclaimer of warranty:
--------------------------------------------------------------------------------
-- THIS SOURCECODE IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
-- THERE IS NO WARRANTY OR SUPPORT FOR THIS SOURCECODE. THE COPYRIGHT HOLDER 
-- PROVIDES THIS SOURCECODE "AS IS" WITHOUT WARRANTY OF ANY KIND,
-- EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
-- WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
-- THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THIS SOURCECODE IS WITH
-- YOU. SHOULD THIS SOURCECODE PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL 
-- NECESSARY SERVICING, REPAIR OR CORRECTION.
--
-- IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES, INCLUDING
-- ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
-- USE OR INABILITY TO USE THIS SOURCECODE (INCLUDING BUT NOT LIMITED TO LOSS OF
-- DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD 
-- PARTIES OR A FAILURE OF THIS SOURCECODE TO OPERATE WITH ANY OTHER
-- SOFTWARE-PROGRAMS, HARDWARE-CIRCUITS OR ANY OTHER KIND OF ASIC OR
-- PROGRAMMABLE LOGIC DESIGN), EVEN IF THE COPYRIGHT HOLDER HAS BEEN ADVISED OF 
-- THE POSSIBILITY OF SUCH DAMAGES.
--------------------------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.wishbone_pkg.all;


package efm02_soc_pkg is

  -- pragma CONST_EXTRACT_ON
  constant MCB_BASEADR : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0000";
  constant BRAM_BASEADR : std_logic_vector((ADR_WIDTH-1) downto 0) := x"1000_0000";
  constant CFG_FLASH_BASEADR : std_logic_vector((ADR_WIDTH-1) downto 0) := x"2000_0000";
  constant GPIO_BASEADR : std_logic_vector((ADR_WIDTH-1) downto 0) := x"4000_0000";
  constant UART_BASEADR : std_logic_vector((ADR_WIDTH-1) downto 0) := x"5000_0000";
  -- pragma CONST_EXTRACT_OFF

  constant MA_fx3_ID : natural := 0;
  
  constant SL_MCB_ID : natural := To_Integer(unsigned(MCB_BASEADR(RNG_SLAVE_SELECT)));
  constant SL_BRAM_ID : natural := To_Integer(unsigned(BRAM_BASEADR(RNG_SLAVE_SELECT)));
  constant SL_CFG_FLASH_ID : natural := To_Integer(unsigned(CFG_FLASH_BASEADR(RNG_SLAVE_SELECT)));
  constant SL_GPIO_ID : natural := To_Integer(unsigned(GPIO_BASEADR(RNG_SLAVE_SELECT)));
  constant SL_UART_ID : natural := To_Integer(unsigned(UART_BASEADR(RNG_SLAVE_SELECT)));
    
end efm02_soc_pkg;
