--------------------------------------------------------------------------------
-- copyright notice:
--------------------------------------------------------------------------------
-- copyright (c) 2010 by
--
-- CESYS GmbH / GERMANY
--
-- http://www.cesys.com
--------------------------------------------------------------------------------
-- author:
--------------------------------------------------------------------------------
-- Stefan Fischer <Stefan.Fischer@cesys.com>
--------------------------------------------------------------------------------
-- license:
--------------------------------------------------------------------------------
-- THIS SOURCECODE IS NOT FREE! IT IS FOR USE TOGETHER WITH CESYS PRODCUTS ONLY!
-- YOU ARE NOT ALLOWED TO MODIFY AND DISTRIBUTE OR USE IT WITH ANY OTHER
-- HARDWARE, SOFTWARE OR ANY OTHER KIND OF ASIC OR PROGRAMMABLE LOGIC DESIGN
-- WITHOUT THE EXPLICIT PERMISSION OF THE COPYRIGHT HOLDER!
--------------------------------------------------------------------------------
-- disclaimer of warranty:
--------------------------------------------------------------------------------
-- THIS SOURCECODE IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
-- THERE IS NO WARRANTY OR SUPPORT FOR THIS SOURCECODE. THE COPYRIGHT HOLDER 
-- PROVIDES THIS SOURCECODE "AS IS" WITHOUT WARRANTY OF ANY KIND,
-- EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
-- WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
-- THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THIS SOURCECODE IS WITH
-- YOU. SHOULD THIS SOURCECODE PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL 
-- NECESSARY SERVICING, REPAIR OR CORRECTION.
--
-- IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES, INCLUDING
-- ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
-- USE OR INABILITY TO USE THIS SOURCECODE (INCLUDING BUT NOT LIMITED TO LOSS OF
-- DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD 
-- PARTIES OR A FAILURE OF THIS SOURCECODE TO OPERATE WITH ANY OTHER
-- SOFTWARE-PROGRAMS, HARDWARE-CIRCUITS OR ANY OTHER KIND OF ASIC OR
-- PROGRAMMABLE LOGIC DESIGN), EVEN IF THE COPYRIGHT HOLDER HAS BEEN ADVISED OF 
-- THE POSSIBILITY OF SUCH DAMAGES.
--------------------------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

use work.wishbone_pkg.all;


package wb_sl_gpio_pkg is
  
  -- pragma CONST_EXTRACT_ON
  constant GPIO_ALIGNMENT : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0004";
  constant GPIO_IO_0_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0000";
  constant GPIO_IO_1_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0004";
  constant GPIO_IO_2_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0008";
  constant GPIO_IO_3_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_000C";
  constant GPIO_IO_4_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0010";
  constant GPIO_IO_5_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0014";
  constant GPIO_IO_6_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0018";
  constant GPIO_IO_7_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_001C";
  constant GPIO_OE_0_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0020";
  constant GPIO_OE_1_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0024";
  constant GPIO_OE_2_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0028";
  constant GPIO_OE_3_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_002C";
  constant GPIO_OE_4_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0030";
  constant GPIO_OE_5_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0034";
  constant GPIO_OE_6_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0038";
  constant GPIO_OE_7_OFFSET : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_003C";
  -- pragma CONST_EXTRACT_OFF
  
  subtype RNG_GPIO_ADR is natural range 5 downto 2;
  
  constant INPUT : std_logic := '0';
  constant OUTPUT : std_logic := not INPUT;

  component wb_sl_gpio
    generic (
      NR_OF_DBGPORTS : positive := 1);
    port (
      syscon_i      : in  rec_syscon_port;
      master_i      : in  rec_master_port;
      slave_o       : out rec_slave_port;
      gpio_output_o : out std_logic_vector(255 downto 0);
      gpio_oe_o     : out std_logic_vector(255 downto 0);
      gpio_input_i  : in  std_logic_vector(255 downto 0);
      debug         : out std_logic_vector((NR_OF_DBGPORTS-1) downto 0));
  end component;

end wb_sl_gpio_pkg;
