--------------------------------------------------------------------------------
-- copyright notice:
--------------------------------------------------------------------------------
-- copyright (c) 2010 by
--
-- CESYS GmbH / GERMANY
--
-- http://www.cesys.com
--------------------------------------------------------------------------------
-- author:
--------------------------------------------------------------------------------
-- Stefan Fischer <Stefan.Fischer@cesys.com>
--------------------------------------------------------------------------------
-- license:
--------------------------------------------------------------------------------
-- THIS SOURCECODE IS NOT FREE! IT IS FOR USE TOGETHER WITH CESYS PRODUCTS ONLY!
-- YOU ARE NOT ALLOWED TO MODIFY AND DISTRIBUTE OR USE IT WITH ANY OTHER
-- HARDWARE, SOFTWARE OR ANY OTHER KIND OF ASIC OR PROGRAMMABLE LOGIC DESIGN
-- WITHOUT THE EXPLICIT PERMISSION OF THE COPYRIGHT HOLDER!
--------------------------------------------------------------------------------
-- disclaimer of warranty:
--------------------------------------------------------------------------------
-- THIS SOURCECODE IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
-- THERE IS NO WARRANTY OR SUPPORT FOR THIS SOURCECODE. THE COPYRIGHT HOLDER 
-- PROVIDES THIS SOURCECODE "AS IS" WITHOUT WARRANTY OF ANY KIND,
-- EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
-- WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
-- THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THIS SOURCECODE IS WITH
-- YOU. SHOULD THIS SOURCECODE PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL 
-- NECESSARY SERVICING, REPAIR OR CORRECTION.
--
-- IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES, INCLUDING
-- ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
-- USE OR INABILITY TO USE THIS SOURCECODE (INCLUDING BUT NOT LIMITED TO LOSS OF
-- DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD 
-- PARTIES OR A FAILURE OF THIS SOURCECODE TO OPERATE WITH ANY OTHER
-- SOFTWARE-PROGRAMS, HARDWARE-CIRCUITS OR ANY OTHER KIND OF ASIC OR
-- PROGRAMMABLE LOGIC DESIGN), EVEN IF THE COPYRIGHT HOLDER HAS BEEN ADVISED OF 
-- THE POSSIBILITY OF SUCH DAMAGES.
--------------------------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

use work.wishbone_pkg.all;


package wb_sl_mcb_pkg is
  
  -- pragma CONST_EXTRACT_ON
  constant MCB_ALIGNMENT : std_logic_vector((ADR_WIDTH-1) downto 0) := x"0000_0004";
  -- pragma CONST_EXTRACT_OFF

  component wb_sl_mcb
    generic (
      NR_OF_DBGPORTS : positive := 1);
    port (
      syscon_i            : in    rec_syscon_port;
      master_i            : in    rec_master_port;
      slave_o             : out   rec_slave_port;
      cmd_clk       : out   std_logic;
      cmd_en        : out   std_logic;
      cmd_instr     : out   std_logic_vector(2 downto 0);
      cmd_bl        : out   std_logic_vector(5 downto 0);
      cmd_byte_addr : out   std_logic_vector(29 downto 0);
      cmd_empty     : in    std_logic;
      cmd_full      : in    std_logic;
      wr_clk        : out   std_logic;
      wr_en         : out   std_logic;
      wr_mask       : out   std_logic_vector(3 downto 0);
      wr_data       : out   std_logic_vector(31 downto 0);
      wr_full       : in    std_logic;
      wr_empty      : in    std_logic;
      wr_count      : in    std_logic_vector(6 downto 0);
      wr_underrun   : in    std_logic;
      wr_error      : in    std_logic;
      rd_clk        : out   std_logic;
      rd_en         : out   std_logic;
      rd_data       : in    std_logic_vector(31 downto 0);
      rd_full       : in    std_logic;
      rd_empty      : in    std_logic;
      rd_count      : in    std_logic_vector(6 downto 0);
      rd_overflow   : in    std_logic;
      rd_error      : in    std_logic;
      debug               : out std_logic_vector((NR_OF_DBGPORTS-1) downto 0));
  end component;

end wb_sl_mcb_pkg;
